/*******************************************************************************
 *	@file			DLShow.cpp
 *	@brief			DirectX Library
 *
 *	@author			ohwhsmm7
 *
 *	@date			24-May-2011(Tue)
 ******************************************************************************/

// vvZbT---------------------------------------------------------------
#include "DLShow.h"

/*******************************************************************************
 *	@namespace	DL
 ******************************************************************************/
namespace	DL
{

// O[oϐ-----------------------------------------------------------

// ֐vg^Cv錾-----------------------------------------------------

// -----------------------------------------------------------------------------
/*******************************************************************************
 *	@fn				CDLMovie::CDLMovie( void )
 *	@retval			none						Ȃ
 *	@brief			RXgN^
 ******************************************************************************/
CDLMovie::CDLMovie( void )
{
}

/*******************************************************************************
 *	@fn				CDLMovie::~CDLMovie( void )
 *	@retval			none						Ȃ
 *	@brief			fXgN^
 ******************************************************************************/
CDLMovie::~CDLMovie( void )
{
}

// -----------------------------------------------------------------------------
// IVMRSurfaceAllocator9
HRESULT CDLShow::InitializeDevice( DWORD_PTR dwUserID,
								   VMR9AllocationInfo *lpAllocInfo,
								   DWORD *lpNumBuffers )
{
	D3DDISPLAYMODE d3ddm;

	if( lpAllocInfo == NULL ) return E_POINTER;
	if( lpNumBuffers == NULL ) return E_POINTER;
	if( m_pAllocNotify9 == NULL ) return E_FAIL;

	HRESULT hr = S_OK;

	if( lpAllocInfo->Format == D3DFMT_UNKNOWN )
	{
		FAIL_RET( m_lpD3DDev->GetDisplayMode( D3DADAPTER_DEFAULT, &d3ddm ) );
		lpAllocInfo->Format = D3DFMT_A8R8G8B8;
	}

	{
		_MEMCHECK( m_pD3DTex->m_byData );
		_RELEASE( m_pD3DTex->m_lpD3DTex );

		int nWidth = lpAllocInfo->dwWidth;
		int nHeight = lpAllocInfo->dwHeight;

		m_pD3DTex->m_nSize = nWidth * nHeight * 4;
		// f[^o^
		m_pD3DTex->m_byData = static_cast<BYTE*>( ::malloc( m_pD3DTex->m_nSize ) );

		// eNX`̍쐬
		hr = D3DXCreateTexture(
				m_lpD3DDev,
				nWidth,
				nHeight,
				D3DX_DEFAULT,
				D3DUSAGE_RENDERTARGET,
				D3DFMT_A8R8G8B8,
				D3DPOOL_DEFAULT,
				&m_pD3DTex->m_lpD3DTex );
		if( FAILED( hr ) )
		{
			DXTRACE_MSG( "D3DXCreateTexture()" );
			return hr;
		}
		// \[X擾
		hr = m_pD3DTex->m_lpD3DTex->GetLevelDesc( 0, &m_pD3DTex->m_D3DDesc );
		if( FAILED( hr ) )
		{
			DXTRACE_MSG( "GetLevelDesc()" );
			return hr;
		}
	}

	lpAllocInfo->dwFlags |= VMR9AllocFlag_TextureSurface;

	m_pSurface9 = NULL;
	FAIL_RET( m_pAllocNotify9->AllocateSurfaceHelper( lpAllocInfo, lpNumBuffers, &m_pSurface9 ) );

	return hr;
}

HRESULT CDLShow::TerminateDevice( DWORD_PTR dwID )
{
	CAutoLock Lock( &m_ObjectLock );

	m_pSurface9 = NULL;

	return S_OK;
}

HRESULT CDLShow::GetSurface( DWORD_PTR dwUserID,
							 DWORD SurfaceIndex,
							 DWORD SurfaceFlags,
							 IDirect3DSurface9 **lplpSurface )
{
	if( lplpSurface == NULL ) return E_POINTER;

	CAutoLock Lock( &m_ObjectLock );

	*lplpSurface = m_pSurface9;
	if( *lplpSurface == NULL ) return E_POINTER;
	(*lplpSurface)->AddRef();

	return S_OK;
}

HRESULT CDLShow::AdviseNotify( IVMRSurfaceAllocatorNotify9 *lpIVMRSurfAllocNotify )
{
	CAutoLock Lock( &m_ObjectLock );
	HRESULT hr = S_OK;

	m_pAllocNotify9 = lpIVMRSurfAllocNotify;

	HMONITOR hMonitor = m_lpD3D->GetAdapterMonitor( D3DADAPTER_DEFAULT );
	FAIL_RET( m_pAllocNotify9->SetD3DDevice( m_lpD3DDev, hMonitor ) );

	return hr;
}

// IVMRImagePresenter9
HRESULT CDLShow::StartPresenting( DWORD_PTR dwUserID )
{
	return S_OK;
}

HRESULT CDLShow::StopPresenting( DWORD_PTR dwUserID )
{
	return S_OK;
}

HRESULT CDLShow::PresentImage( DWORD_PTR dwUserID,
							   VMR9PresentationInfo *lpPresInfo )
{
	if( lpPresInfo == NULL ) return E_POINTER;
	else if( lpPresInfo->lpSurf == NULL ) return E_POINTER;
	if( m_pD3DTex->m_lpD3DTex == NULL ) return E_POINTER;

	CAutoLock Lock( &m_ObjectLock );
	HRESULT hr = S_OK;
/*
	// eNX`͗pӂĂ
	LPDIRECT3DSURFACE9 pSurf;
	FAIL_RET( m_pD3DTex->m_lpD3DTex->GetSurfaceLevel( 0, &pSurf ) );

	FAIL_RET( m_lpD3DDev->StretchRect( lpPresInfo->lpSurf, NULL, pSurf, NULL, D3DTEXF_NONE ) );

	pSurf->Release();
*/
	return hr;
}

// IUnknown
HRESULT CDLShow::QueryInterface( REFIID riid,
								 void** ppvObject )
{
	HRESULT hr = E_NOINTERFACE;

	if( ppvObject == NULL )
		hr = E_POINTER;
	else
	if( riid == IID_IVMRSurfaceAllocator9 )
	{
		*ppvObject = static_cast<IVMRSurfaceAllocator9*>( this );
		AddRef();
		hr = S_OK;
	}else
	if( riid == IID_IVMRImagePresenter9 )
	{
		*ppvObject = static_cast<IVMRImagePresenter9*>( this );
		AddRef();
		hr = S_OK;
	}else
	if( riid == IID_IUnknown )
	{
		*ppvObject = static_cast<IUnknown*>( static_cast<IVMRSurfaceAllocator9*>( this ) );
		AddRef();
		hr = S_OK;
	}
	
	return hr;
}

ULONG CDLShow::AddRef()
{
	return InterlockedIncrement( &m_refCount );
}

ULONG CDLShow::Release()
{
	return InterlockedDecrement( &m_refCount );
}

/*******************************************************************************
 *	@fn				CDLShow::CDLShow( void )
 *	@retval			none						Ȃ
 *	@brief			RXgN^
 ******************************************************************************/
CDLShow::CDLShow( void )
	: m_hWnd()
	, m_lpD3D()
	, m_lpD3DDev()
	, m_pD3DTex()
	, m_refCount( 1 )
	, m_ObjectLock()

	, m_CMovie()

	, m_pBuilder()
	, m_pFilter()
	, m_pConfig9()
	, m_pAlloc9()
	, m_pAllocNotify9()
	, m_pSurface9()
	, m_pControl()
{
}

/*******************************************************************************
 *	@fn				CDLShow::~CDLShow( void )
 *	@retval			none						Ȃ
 *	@brief			fXgN^
 ******************************************************************************/
CDLShow::~CDLShow( void )
{
	End();
}

/*******************************************************************************
 *	@fn				int CDLShow::Init( const HWND& hWnd,
 *									   const LPDIRECT3D9& lpD3D,
 *									   const LPDIRECT3DDEVICE9& lpD3DDev )
 *	@param[in]		hWnd						EChEnh
 *	@param[in]		lpD3D						Direct3D IuWFNg
 *	@param[in]		lpD3DDev					Direct3D foCX
 *	@retval			int							TRUE=OK/FALSE=NG
 *	@brief			
 ******************************************************************************/
int CDLShow::Init( const HWND& hWnd,
				   const LPDIRECT3D9& lpD3D,
				   const LPDIRECT3DDEVICE9& lpD3DDev )
{
	HRESULT hr = S_OK;
	m_hWnd = hWnd;
	m_lpD3D = lpD3D;
	m_lpD3DDev = lpD3DDev;

	// IGraphBuilder ̏
	FAIL_RET( ::CoCreateInstance( CLSID_FilterGraph, NULL, CLSCTX_INPROC_SERVER, IID_IGraphBuilder, (void**)&m_pBuilder ) );

	// IBaseFilter ̏
	FAIL_RET( ::CoCreateInstance( CLSID_VideoMixingRenderer9, NULL, CLSCTX_INPROC_SERVER, IID_IBaseFilter, (void**)&m_pFilter ) );

	// IVMRFilterConfig9 ̐ݒ
	FAIL_RET( m_pFilter->QueryInterface( IID_IVMRFilterConfig9, reinterpret_cast<void**>( &m_pConfig9 ) ) );

	// _OX [h̐ݒ
	FAIL_RET( m_pConfig9->SetRenderingMode( VMR9Mode_Renderless ) );

	// ~LVOXg[̐ݒi~LVO\͂܂̂ƂȂj
	FAIL_RET( m_pConfig9->SetNumberOfStreams( 1 ) );

	// IVMRSurfaceAllocatorNotify9 ̐ݒ
	FAIL_RET( m_pFilter->QueryInterface( IID_IVMRSurfaceAllocatorNotify9, reinterpret_cast<void**>( &m_pAllocNotify9 ) ) );

	// JX^T[tFCXAP[^̎wg擾
	m_pAlloc9.Attach( this );

	// JX^AP[^v[^g悤w
	FAIL_RET( m_pAllocNotify9->AdviseSurfaceAllocator( USERID, m_pAlloc9 ) );

	// VMR-9 ƃAP[^ v[^Ԃ̒ʐMNm
	FAIL_RET( m_pAlloc9->AdviseNotify( m_pAllocNotify9 ) );

	// OtɃtB^ǉ
	FAIL_RET( m_pBuilder->AddFilter( m_pFilter, L"Video Mixing Renderer 9" ) );

	// IMediaControl ̐ݒ
	FAIL_RET( m_pBuilder->QueryInterface( IID_IMediaControl, reinterpret_cast<void**>( &m_pControl ) ) );

	return TRUE;
}

/*******************************************************************************
 *	@fn				int CDLShow::End( void )
 *	@retval			int							TRUE=OK/FALSE=NG
 *	@brief			I
 ******************************************************************************/
int CDLShow::End( void )
{
	m_pControl = NULL;
	m_pSurface9 = NULL;
	m_pAllocNotify9 = NULL;
	m_pAlloc9 = NULL;
	m_pConfig9 = NULL;
	m_pFilter = NULL;
	m_pBuilder = NULL;

	return TRUE;
}

/*******************************************************************************
 *	@fn				int CDLShow::Update( void )
 *	@retval			int							TRUE=OK/FALSE=NG
 *	@brief			ʍXV
 *					{ PresentImage ōs鏈
 ******************************************************************************/
int CDLShow::Update( void )
{
	CAutoLock Lock( &m_ObjectLock );
	HRESULT hr = S_OK;

	// eNX`͗pӂĂ
	LPDIRECT3DSURFACE9 pSurf;
	FAIL_RET( m_pD3DTex->m_lpD3DTex->GetSurfaceLevel( 0, &pSurf ) );

	FAIL_RET( m_lpD3DDev->StretchRect( m_pSurface9, NULL, pSurf, NULL, D3DTEXF_NONE ) );

	pSurf->Release();

	return TRUE;
}

/*******************************************************************************
 *	@fn				int CDLSound::LoadMov( const LPWSTR& szName,
 *										   D3DTEXTURE* pD3DTex )
 *	@param[in]		szName						t@C
 *	@param[in]		pD3DTex						eNX`\
 *	@retval			int							TRUE=OK/FALSE=NG
 *	@brief			[r[ǂݍ
 ******************************************************************************/
int CDLShow::LoadMov( const LPWSTR& szName,
					  D3DTEXTURE* pD3DTex )
{
	HRESULT hr = S_OK;
	m_pD3DTex = pD3DTex;

	// ǂݍ
	FAIL_RET( m_pBuilder->RenderFile( szName, NULL ) );

	return TRUE;
}

/*******************************************************************************
 *	@fn				int CDLShow::RemoveMov( void )
 *	@retval			int							TRUE=OK/FALSE=NG
 *	@brief			[r[
 ******************************************************************************/
int CDLShow::RemoveMov( void )
{
	if( m_pControl != NULL )
		m_pControl->Stop();

	return TRUE;
}

/*******************************************************************************
 *	@fn				int CDLShow::RemoveALL( void )
 *	@retval			int							TRUE=OK/FALSE=NG
 *	@brief			fޑS
 ******************************************************************************/
int CDLShow::RemoveALL( void )
{
	return TRUE;
}

/*******************************************************************************
 *	@fn				int CDLShow::Play( void )
 *	@retval			int							TRUE=OK/FALSE=NG
 *	@brief			[r[Đ
 ******************************************************************************/
int CDLShow::Play( void )
{
	if( m_pControl != NULL )
		m_pControl->Run();

	return TRUE;
}

/*******************************************************************************
 *	@fn				int CDLShow::Stop( void )
 *	@retval			int							TRUE=OK/FALSE=NG
 *	@brief			[r[~
 ******************************************************************************/
int CDLShow::Stop( void )
{
	if( m_pControl != NULL )
		m_pControl->Stop();

	return TRUE;
}

}	// namespace	DL
