/*******************************************************************************
 *	@file			DLShow.h
 *	@brief			DirectX Library
 *
 *	@author			ohwhsmm7
 *
 *	@date			24-May-2011(Tue)
 ******************************************************************************/

#ifndef	__DLSHOW_INCLUDE__
#define	__DLSHOW_INCLUDE__

// vvZbT---------------------------------------------------------------
#include "DL.h"
#include "DLGraph.h"
#include <vmr9.h>
#include "DLShow\\smartptr.h"
#include "DLShow\\wxutil.h"

#ifdef __cplusplus
extern "C" {
#endif

/*******************************************************************************
 *	@namespace	DL
 ******************************************************************************/
namespace	DL
{

// 萔`---------------------------------------------------------------------
#pragma once

#define FAIL_RET(x) do { if( FAILED( hr = ( x  ) ) ) return hr; } while(0)

// 񋓌^`-------------------------------------------------------------------

// \̒`-------------------------------------------------------------------

// NX-----------------------------------------------------------------------
/*******************************************************************************
 *	@class		CDLShow			DLShow.h			"DLShow.h"
 *	@brief		CDLMovieNX
 ******************************************************************************/
class CDLMovie
{
// 萔`---------------------------------------------------------------------
private:
protected:
public:

// o֐-------------------------------------------------------------------
private:
protected:
public:
	CDLMovie( void );
	~CDLMovie( void );

// oϐ-------------------------------------------------------------------
private:
protected:
public:

};

/*******************************************************************************
 *	@class		CDLShow			DLShow.h			"DLShow.h"
 *	@brief		CDLShowNX
 ******************************************************************************/
class CDLShow
	: IVMRSurfaceAllocator9
	, IVMRImagePresenter9
{
// 萔`---------------------------------------------------------------------
private:
	static const int USERID			= 0xACDCACDC;								//!< VMR-9 ̃CX^Xw

protected:
public:

// o֐-------------------------------------------------------------------
private:
	// IVMRSurfaceAllocator9
	virtual HRESULT STDMETHODCALLTYPE InitializeDevice( DWORD_PTR dwUserID,
														VMR9AllocationInfo *lpAllocInfo,
														DWORD *lpNumBuffers );

	virtual HRESULT STDMETHODCALLTYPE TerminateDevice( DWORD_PTR dwID );

	virtual HRESULT STDMETHODCALLTYPE GetSurface( DWORD_PTR dwUserID,
												  DWORD SurfaceIndex,
												  DWORD SurfaceFlags,
												  IDirect3DSurface9 **lplpSurface );

	virtual HRESULT STDMETHODCALLTYPE AdviseNotify( IVMRSurfaceAllocatorNotify9 *lpIVMRSurfAllocNotify );

	// IVMRImagePresenter9
	virtual HRESULT STDMETHODCALLTYPE StartPresenting( DWORD_PTR dwUserID );

	virtual HRESULT STDMETHODCALLTYPE StopPresenting( DWORD_PTR dwUserID );

	virtual HRESULT STDMETHODCALLTYPE PresentImage( DWORD_PTR dwUserID,
													VMR9PresentationInfo *lpPresInfo );

	// IUnknown
	virtual HRESULT STDMETHODCALLTYPE QueryInterface( REFIID riid,
													  void** ppvObject );
	virtual ULONG STDMETHODCALLTYPE AddRef();
	virtual ULONG STDMETHODCALLTYPE Release();

protected:
public:
	CDLShow( void );
	~CDLShow( void );

	int Init( const HWND& hWnd,
			  const LPDIRECT3D9& lpD3D,
			  const LPDIRECT3DDEVICE9& lpD3DDev );								//!< 
	int End( void );															//!< I

	int Update( void );															//!< XV

	// fޓǂݍ
	int LoadMov( const LPWSTR& szName,
				 D3DTEXTURE* pD3DTex );

	// fމ
	int RemoveMov( void );
	int RemoveALL( void );

	// IuWFNgǉ

	// IuWFNg폜

	// IuWFNgs
	int Play( void );
	int Stop( void );

// oϐ-------------------------------------------------------------------
private:
	HWND					m_hWnd;												//!< EChEnh
	LPDIRECT3D9				m_lpD3D;											//!< Direct3D IuWFNg
	LPDIRECT3DDEVICE9		m_lpD3DDev;											//!< Direct3D foCX
	D3DTEXTURE*				m_pD3DTex;											//!< eNX`\
	long					m_refCount;
	CCritSec				m_ObjectLock;

	// IuWFNg
	CDLMovie				m_CMovie;

	//
	SmartPtr<IGraphBuilder>				m_pBuilder;
	SmartPtr<IBaseFilter>				m_pFilter;
	SmartPtr<IVMRFilterConfig9>			m_pConfig9;
	SmartPtr<IVMRSurfaceAllocator9>		m_pAlloc9;
    SmartPtr<IVMRSurfaceAllocatorNotify9>	m_pAllocNotify9;
	SmartPtr<IDirect3DSurface9>			m_pSurface9;
	SmartPtr<IMediaControl>				m_pControl;

protected:
public:

};

// OO[oϐ-----------------------------------------------------------

// O֐vg^Cv錾-----------------------------------------------------

}	// namespace	DL

#ifdef __cplusplus
}
#endif

#endif	// __DLSHOW_INCLUDE__
